<?php

class Custom_NavConnector_Block_Adminhtml_Actions_Customer_SecondExampleButton extends Mage_Adminhtml_Block_System_Config_Form_Field
{
    /*
     * Set template
     */
    protected function _construct()
    {
        parent::_construct();
        $this->setTemplate('navconnector/system/config/customer/secondbutton.phtml');
    }

    /**
     * Return element html
     *
     * @param  Varien_Data_Form_Element_Abstract $element
     * @return string
     */
    protected function _getElementHtml(Varien_Data_Form_Element_Abstract $element)
    {
        return $this->_toHtml();
    }

    /**
     * Return ajax url for button
     *
     * @return string
     */
    public function getAjaxCheckUrl()
    {
        return Mage::helper('adminhtml')->getUrl('adminhtml/navcustomer/secondexample');
    }

    /**
     * Generate button html
     *
     * @return string
     */
    public function getButtonHtml()
    {
        /** @var Mage_Core_Block_Abstract $button */
        $button = $this->getLayout()->createBlock('adminhtml/widget_button')
            ->setData(array(
                'id'        => 'customer_second_example',
                'label'     => $this->helper('adminhtml')->__('Second example'),
                'onclick'   => 'javascript:customerSecondButton(); return false;'
            ));

        return $button->toHtml();
    }
}
