<?php

class Navision_WebserviceClient
{
    /**
     * @var string
     */
    protected $wsdlUrl;

    /**
     * Navision_WebserviceClient constructor.
     */
    public function __construct()
    {
        $webserviceConfig = Mage::getStoreConfig('navision_config/webservice_config');
        $this->wsdlUrl    = $webserviceConfig['url'];
        $user             = $webserviceConfig['user'];
        $password         = $webserviceConfig['password'];
        $domain           = $webserviceConfig['domain'];
        define('USERPWD', $domain . "\\" . $user . ":" . $password);
    }

    /**
     * @param $method
     * @param $params
     * @return mixed
     * @throws Exception
     */
    public function __call($method, $params)
    {
        try {
            // Remove HTTP stream registry
            stream_wrapper_unregister('http');

            // Register our defined NTLM stream
            if (!stream_wrapper_register('http', 'Navision_NTLMStream')) {
                throw new Exception("Unable to register HTTP Handler");
            }

            $soapClient = new Navision_NTLMSoapClient($this->wsdlUrl);
            $response = call_user_func(array($soapClient, $method), $params);

            // Since our instance is using the defined NTLM stream,
            // you now need to reset the stream wrapper to use the default HTTP.
            // This way you're not messing with the rest of your application or dependencies.
            stream_wrapper_restore('http');

            return $response;
        } catch (SoapFault $ex) {
            throw new Exception($ex->getMessage());
        }
    }
}
